import java.util.concurrent.LinkedBlockingQueue;

class LineThread implements Runnable
{
  LinkedBlockingQueue <Word> _q;
  String _line;
  int _limit;
  
  public LineThread (LinkedBlockingQueue <Word> q, int limit)
  {
    _q     = q;
    _line  = "";
    _limit = limit;
  }
  
  public String getLine ()
  {
    return _line;
  }
  
  public void run ()
  {
    while (_limit > 0)
      {
        try 
          {
            Word w = _q.take ();
            
            if (_limit - w.syllables () >= 0)
              {
                _line  += (w + " ");
                _limit -= w.syllables ();
              }
          }
        catch (InterruptedException e) 
          {
            throw new RuntimeException ("Haiku Interrupted");
          }
      }
  }
}